tbb::internal::tls< T * > Class Template Reference

`#include <tls.h>`

Inheritance diagram for tbb::internal::tls< T * >:
Collaboration diagram for tbb::internal::tls< T * >:

## Public Member Functions

| tls ()
| ~tls ()
T * | operator= (T *value)
| operator T* ()
T * | operator-> ()
T & | operator* ()

## Private Types

typedef basic_tls< T * > | base

## Private Member Functions

T * | internal_get ()
Private Member Functions inherited from tbb::internal::basic_tls< T * >
int | create ()
int | destroy ()
void | set (T * value)
T * | get ()

## Static Private Member Functions

static void | internal_dtor (void *ptr)

## Detailed Description

### template<typename T>
class tbb::internal::tls< T * >

Definition at line 88 of file tls.h.

## Member Typedef Documentation

## base

template<typename T >

typedef basic_tls<T*> tbb::internal::tls< T * >::base

private

Definition at line 89 of file tls.h.

## Constructor & Destructor Documentation

## tls()

template<typename T >

tbb::internal::tls< T * >::tls | ( |  | ) |

inline

Definition at line 102 of file tls.h.

{
#if USE_PTHREAD
base::create( internal_dtor );
#else
base::create();
#endif
}
tbb::internal::basic_tls::create
int create()
Definition: tls.h:48
tbb::internal::tls< T * >::internal_dtor
static void internal_dtor(void *ptr)
Definition: tls.h:90

## ~tls()

template<typename T >

tbb::internal::tls< T * >::~tls | ( |  | ) |

inline

Definition at line 109 of file tls.h.

{ base::destroy(); }
tbb::internal::basic_tls::destroy
int destroy()
Definition: tls.h:55

## Member Function Documentation

## internal_dtor()

template<typename T >

static void tbb::internal::tls< T * >::internal_dtor | ( | void * | ptr | ) |

inline static private

Definition at line 90 of file tls.h.

{
if (ptr) delete (T*)ptr;
}

## internal_get()

template<typename T >

T* tbb::internal::tls< T * >::internal_get | ( |  | ) |

inline private

Definition at line 93 of file tls.h.

{
T* result = base::get();
if (!result) {
result = new T;
base::set(result);
}
return result;
}
tbb::internal::basic_tls::set
void set(T value)
Definition: tls.h:56
tbb::internal::basic_tls::get
T get()
Definition: tls.h:57

## operator T*()

template<typename T >

tbb::internal::tls< T * >::operator T* | ( |  | ) |

inline

Definition at line 111 of file tls.h.

{ return internal_get(); }
tbb::internal::tls< T * >::internal_get
T * internal_get()
Definition: tls.h:93

## operator*()

template<typename T >

T& tbb::internal::tls< T * >::operator* | ( |  | ) |

inline

Definition at line 113 of file tls.h.

{ return *internal_get(); }

## operator->()

template<typename T >

T* tbb::internal::tls< T * >::operator-> | ( |  | ) |

inline

Definition at line 112 of file tls.h.

{ return internal_get(); }

## operator=()

template<typename T >

T* tbb::internal::tls< T * >::operator= | ( | T * | value | ) |

inline

Definition at line 110 of file tls.h.

{ base::set(value); return value; }
value
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain __itt_id ITT_FORMAT p const __itt_domain __itt_id __itt_timestamp __itt_timestamp ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain ITT_FORMAT p const __itt_domain __itt_string_handle unsigned long long value
Definition: ittnotify_static.h:192

References value.

The documentation for this class was generated from the following file:

- tls.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.